
    var topBarHeight,
        navHeight,
        offset,
        offsetFactor,
        startFix = false,
        isMobileNav = false;
const   breakingPointFixed = 630,
        body = document.querySelector("body"),
        topBar = document.querySelector("#top-bar"),
        navigation = document.querySelector("nav"),
        mobileNavigationHeight = "70px",
        menuItems = document.querySelectorAll("nav > ul > li > a"),
        scrollPaddingTop = "10px",
        scrollPaddingBottom = "10px",
        mobileFixed = true;

document.fonts.ready.then(function () {
    setAll();
});

function setFactor() {
    let navHeightSingle = menuItems[0].offsetHeight;
    if (navigation.offsetHeight > navHeightSingle) {
        let div = Math.floor(navigation.offsetHeight / navHeightSingle);
        offsetFactor = div;
    } else {
        offsetFactor = 1;
    }
}
function setAll() {
    navHeight = navigation.offsetHeight;
    topBarHeight = topBar.offsetHeight;
    setFactor();
    let defaultPaddingTop = getComputedStyle(menuItems[0]).paddingTop;
    let defaultPaddingBottom = getComputedStyle(menuItems[0]).paddingBottom;
    offset = parseInt(defaultPaddingTop) + parseInt(defaultPaddingBottom) - parseInt(scrollPaddingTop) - parseInt(scrollPaddingBottom);
    navigation.style.cssText = "top:" + (navHeight * -1) + "px;margin-top:" + navHeight + "px;";
    function setFixed() {
        navigation.classList.add("fixed");
        navigation.classList.add("smoothed-in");
        navigation.style.cssText = "top:" + (navHeight) + "px;margin-top:" + (navHeight * -1) + "px;";
        body.style.paddingTop = navHeight + "px";
    }
    function removeScrollPadding() {
        for (let menuItem of  menuItems) {
            menuItem.style.padding = "";
        }
    }
    window.addEventListener("scroll", function (event) {
        var scrollPos = window.scrollY;
        if (!isMobileNav) {
            if (!startFix) {
                startFix = true;
                return false;
            }
            if (scrollPos > topBarHeight + 1 * navHeight) {
                navigation.style.marginBottom = "0px";
                for (let menuItem of  menuItems) {
                    menuItem.style.cssText = "padding-top:" + scrollPaddingTop + ";padding-bottom:" + scrollPaddingBottom + ";";
                }
                setFixed();
            } else if (scrollPos <= topBarHeight + offset * offsetFactor) {
                navigation.style.cssText = "top:0px;margin-top:0px;";
                navigation.classList.remove("fixed");
                navigation.classList.remove("smoothed-in");
                body.style.paddingTop = "0px";
                removeScrollPadding();
                if (isMobileNav) {
                    navigation.style.marginTop = "0px";
                    navHeight = navigation.offsetHeight;
                    topBarHeight = topBar.offsetHeight;
                    removeScrollPadding();
                }
            }
        } else {
            if (scrollPos > topBarHeight && mobileFixed) {
                navigation.classList.add("fixed");
                body.style.paddingTop = navHeight + "px";
            } else if (scrollPos <= topBarHeight) {
                body.style.paddingTop = "0px";
                navigation.classList.remove("fixed");
            }
        }
    });
    navigation.style.marginBottom = (-1 * navHeight) + "px";
    if (window.innerWidth < breakingPointFixed) {
        setMobileNav();
    } else {
        isMobileNav = false;
    }
}
function setMobileNav() {
    isMobileNav = true;
    navigation.classList.remove("fixed");
    navigation.style.cssText = "top:0px;margin-top:0;height:" + mobileNavigationHeight + ";padding-top:" + mobileNavigationHeight + ";";
    navigation.classList.remove("smoothed-in");
    navHeight = navigation.offsetHeight;
    navigation.style.height = mobileNavigationHeight + "px";
}
window.addEventListener("resize", () => {
    setFactor();
    navHeight = navigation.offsetHeight;
    topBarHeight = topBar.offsetHeight;
    if (window.innerWidth < breakingPointFixed) {
        setMobileNav();
        body.style.paddingTop = "";
        navigation.style.marginBottom = "";
    } else {
        navigation.style.paddingTop = "";
        navigation.style.height = "";
        isMobileNav = false;
    }
});