$(document).ready(function () {
    var topBarHeight,
            navHeight,
            offset,
            offsetFactor,
            startFix = false,
            isMobileNav = false;
    const  breakingPoint = 630,
            navigation = $("nav"),
            topBar = $("#top-bar"),
            mobileNavigationHeight = "70px",
            menuItems = $("nav > ul > li > a"),
            scrollPaddingTop = "10px",
            scrollPaddingBottom = "10px",
            mobileFixed = true;
    document.fonts.ready.then(function () {
        setAll();
    });
    function setFactor() {
        let navHeightSingle = menuItems.outerHeight();
        if (navigation.height() > navHeightSingle) {
            let div = Math.floor(navigation.height() / navHeightSingle);
            offsetFactor = div;
        } else {
            offsetFactor = 1;
        }
    }
    function setAll() {
        navHeight = navigation.height();
        topBarHeight = topBar.height();
        setFactor();
        let defaultPaddingTop = menuItems.css("padding-top");
        let defaultPaddingBottom = menuItems.css("padding-bottom");
        offset = parseInt(defaultPaddingTop) + parseInt(defaultPaddingBottom) - parseInt(scrollPaddingTop) - parseInt(scrollPaddingBottom);
        navigation.css("top", navHeight * -1).css("margin-top", navHeight);
        function setFixed() {
            navigation.addClass("fixed smoothed-in").css({'top': navHeight, 'margin-top': navHeight * -1});
            $("body").css("padding-top", navHeight);
        }
        function removeScrollPadding() {
            menuItems.css("padding", "");
        }
        $(window).scroll(function () {
            var scrollPos = $(document).scrollTop();
            if (!isMobileNav) {
                if (!startFix) {
                    navigation.css("margin-bottom", "");
                    startFix = true;
                    return false;
                }
                if (scrollPos > topBarHeight + 1 * navHeight) {
                    navigation.css("margin-bottom", "0px");
                    menuItems.css({'padding-top': scrollPaddingTop, 'padding-bottom': scrollPaddingBottom});
                    setFixed();
                } else if (scrollPos <= topBarHeight + offset * offsetFactor) {
                    navigation.css({'top': "0", 'margin-top': '0'}).removeClass("fixed smoothed-in");
                    $("body").css("padding-top", "");
                    removeScrollPadding();
                    if (isMobileNav) {
                        navigation.css("margin-top", "0");
                        navHeight = navigation.height();
                        topBarHeight = topBar.height();
                        removeScrollPadding();
                    }
                }
            } else {
                if (scrollPos > topBarHeight && mobileFixed) {
                    navigation.addClass("fixed");
                    $("body").css("paddingTop", navHeight);
                } else if (scrollPos <= topBarHeight) {
                    $("body").css("paddingTop", "0px");
                    navigation.removeClass("fixed");
                }
            }
        });
        navigation.css("margin-bottom", -1 * navHeight);
        if ($(window).outerWidth() < breakingPoint) {
            setMobileNav();
        } else {
            isMobileNav = false;
        }
    }
    function setMobileNav() {
        isMobileNav = true;
        navigation.removeClass("fixed");
        navigation.css({'top': '0', 'margin-top': '0', 'height': mobileNavigationHeight, 'padding-top': mobileNavigationHeight}).removeClass("smoothed-in");
        navHeight = navigation.outerHeight();
        navigation.css("height", mobileNavigationHeight);
    }
    $(window).resize(function () {
        setFactor();
        navHeight = navigation.height();
        topBarHeight = topBar.height();
        if ($(window).outerWidth() < breakingPoint) {
            setMobileNav();
            navigation.css("margin-bottom", "");
            $("body").css("padding-top", "");
        } else {
            navigation.css({'padding-top': '', 'height': ''});
            isMobileNav = false;
        }
    });
});